;rockyone			pour MI-3 MI-9			 22/01/2017
;
;
;			OPEN/SAVE PABLO v1.1   .PPP
;			---------------------------
;               This format does not contain a color cycle
;
; 
;	  
;
; Res%	     : 0 OR 1  = PPP 
;		    2  = PA3 
; 
; File_size% :  for Open, zero for save
;
;       	Call Ppp_Os( L Source+0, L But+0, W Res%, W file_size% )
;       	--------------------------------------------------------
;
;       
; For open
;	Load file.PPP to Source+0
;	Recalibrate data in tny format by Ppp_Os
;	Depack by Tny_open
;
;                file size+1,   file size         ........SIZE BUFFER
;	Ppp_Os( L source_ppp, L but_tny,W rez%,0 )          
;	   * The data is written in But+1 for Tny_Open   
;
;  	                         320034
;	Tny_Open( L but_tny, L buffer_pi1,L Anime,W Rez%,W File_size%)
;		The two routine return
;		In low d0   	-1 error resolution   
;	                        -2 error header    
;		In high d0      alway picture resolution
;                            
;.......................................................
;
; For save
;	Load file.PI1 to Source+1
;	Save in format Tny
;	Recalibrate data in PPP format by Ppp_Os
;
;	      file size+32003,   32047
;	Tny_Save( L Soure_Pi1,L But_Tny,L Anime) 
;		* The data is written in But_tny+1
;
;                  32047      32083
;	Ppp_Os( L But_Tny, L but_PPP,1)
;		
;		The two routine return
;		In low d0       -1 error resolution              
;		In low d0  	file size if not error 
;		in high d0	alway image resolution 
;.......................................................
;
; Buffer Anime for Tny, here contains 140 byte null.
;-----------------------------------------------------
;  
;; image "PABLO.PPP"
;+    0 	33 byte          		Header
;+   34		 2 byte		$0d,$0a		end string
;+   36 	 5 byte		#16040		Size image data+38 in ascii  
;+   41 	 2 byte		$0d,$0a		end string
;+   43		 1 word 	$00,$1d		Flag PPP and PA3		
;+   45		 1 word		$3ea8		size image data +38
;+   47		16 word                 	color palette
;+   79		 ? word                 	word data		
;+12349		 ? byte	                	bytes of control
;+16081		 1 word  	$0e94 = 3732	number of bytes of control
;
;+16083  End fille
;
;------------------------------------------------------------------------
    
	movem.l	d1-d7/a0-a6,-(sp)
	movem.l	60(sp),a0-a1

;.......................................Test screen resolution.........
	moveq.l	#-1,d0			;R. error

	move.w	68(sp),d2	
	move.w	d2,d4			;R. resolution image
	andi.b	#2,d2
	move.b	$44c,d1
	andi.b	#2,d1
	cmp.b	d1,d2
	bne	end_prg

	lea.l	header(pc),a3
	moveq.l	#35,d1			; lenght of header -1
	
;......................................
	move.w	70(sp),d2		; open or save ?
	bne.s	open

;.......................................SAVE TNY to PPP .................

save:	addq.l	#1,a0		; tny write to buf+1
	
	movea.l a1,a4           ; to calculate file size

 	cmp.b   #3,(a0)+	; Cycle color in Source ?
	bmi.s   not_cycle	; No ! 
	addq.l  #4,a0		; Jump color cycle
 
not_cycle:    
	lea.l	32(a0),a6	; Source point to number of byte of control

write_header:
	move.b	(a3)+,(a1)+	
	dbra.w	d1,write_header

	move.w	(a6)+,d6	; read the number of byte of control
	move.w	(a6)+,d7	; read the number of word of data
;				; Source a6 point to first bytes of control

	lsl.w	#1,d7		; 
	move.w	d6,d5		; total data +38
	add.w	d7,d5		;
	addi.w	#38,d5		;

	bsr 	hex_ascii       ; +36 write total data in ascii

	subq.l	#2,a3		; return to $0d0a
	moveq.l	#3,d1
after:	move.b	(a3)+,(a1)+	; +41~  $0d0a end string
;			        ; +43~ $001d flag PPP and PA3
	dbra.w	d1,after

	move.b	d5,1(a1)	; +45~ write total data
	lsr.w	#8,d5
	move.b	d5,(a1)
	addq.l	#2,a1	

	bsr.s	palette         ; +47~	a6 to a1

	lea.l	0(a6,d6.w),a0	; Source a0 point to address word data

	bsr.s   copy_word	; a0 to a1
	bsr.s   copy_byte	; a6 to a1

	move.b  d6,1(a1)	; write number bytes of control
	lsr.w	#8,d6
	move.b	d6,(a1)
	addq.l	#2,a1

	suba.l  a4,a1		; calculat file size
	move.l	a1,d0		; return file size
	
	bra.s   end_prg
;
;.......................................
palette:	move.l	#31,d3		; 16 color
color:		move.b	(a0)+,(a1)+
		dbra.w	d3,color
		rts

;.......................................
copy_word:	subq.b	#1,d7
copy_w:		move.b  (a0)+,(a1)+
		dbra.w  d7,copy_w
		rts  
;.......................................
copy_byte:	move.w	d6,d3
		subq.b	#1,d3
copy_b:       	move.b  (a6)+,(a1)+
		dbra.w  d3,copy_b
		rts            
;.......................................OPEN.PPP to TNY .................
;d1=35

open:	movea.l	a0,a4

	moveq.l	#-2,d0			; R. error
test_h:	cmpm.b	(a3)+,(a0)+		; test header
	bne.s	end_prg
	dbra.w	d1,test_h

jump:	cmpi.b	#$0a,(a0)+		; skip number in ascii
	bne.s	jump

	moveq.l	#1,d1
after2:	cmpm.b	(a3)+,(a0)+		;end ascii,and  flag PPP or PA3
	bne.s	end_prg
	dbra.w	d1,after2

	move.b	(a0)+,d7		; read total size data
	lsl.w	#8,d7
	move.b	(a0)+,d7	

	move.w	d4,(a1)+		; write resolution

	bsr.s	palette			; a0 to a1

	move.w	70(sp),d1		; read file size .PPP
	lea.l	-2(a4,d1.w),a4		; point to eof file -2
	move.b	(a4)+,d6		; read number of bytes of control
	lsl.w	#8,d6
	move.b	(a4),d6		
	
	sub.w	d6,d7		; Calculating the size of data of image
	subi.w	#38,d7		; word - 38
		
	move.w	d6,(a1)+	; write the number of byte of control

	move.w	d7,d5		; write the number of image word data
	lsr.w	#1,d5		;
	move.w	d5,(a1)+	;

;				; Source a0 point to words image data
; 				; Source a6 point to bytes of control
;				; But    a1   "    "   "   "     "

	lea.l	0(a0,d7.w),a6
	bsr.s   copy_byte	; a6 to a1
	bsr.s	copy_word	; a0 to a1
	
	moveq.l	#0,d0
;......................................

end_prg:	
	swap	d0
	move.w	d4,d0
	swap 	d0

	movem.l (sp)+,d1-d7/a0-a6
	rts
;........................................
hex_ascii:	
	moveq.l	#0,d2
	move.w	d5,d1
decimal:
	ext.l	d1
	beq.s	ascii	
	divu.w	#10,d1
	swap	d1
	lsl.l	#4,d2
	add.b	d1,d2
	addi.b	#1,d2
	swap	d1
	bra.s	decimal
ascii:	move.b	d2,(a1)
	and.b	#$f,(a1)
	add.b	#$2f,(a1)+
	lsr.l	#4,d2
	bne.s	ascii
	rts	
;........................................

;......................................
header:	even
	dc.b	'PABLO PACKED PICTURE: Groupe CDND ',$0d,$0a,$00,$1d
	even

	end
;                         **************************