;-------------------------------------------------------------------------
;      " DEGAS Elite Packer by Nucleus/HMD for Synthetic Arts III! "
;(PC1 only)
; compactage par comparaison sur 3 octets
;-------------------------------------------------------------------------
; Modifi pour sauvegarde PC1-3
;
; Rockyone			pour MI-3 & Mi-9		05/09/2017
;
; SOURCE	Buffer image format degas
; BUT		Buffer 34160 octet
; ANIME		Buffer 32 octet contenant les cycle de couleur
;		ou adresse SOURCE+32034
; PACK		$1 pour compression. Sinon $0		
; CYCLE	      	$1 pour sauver les cycle de couleurs. Sinon $0
;			
;               	
;	Call Pc_save( L source, L but, L anime, W pack%, W cycle% )
;
; Retour dans low  D0  la taille du fichier
;-------------------------------------------------------------------------
		movem.l	d1-d7/a0-a6,-(sp)
		movem.l	60(sp),a0-a1
		move.b	1(a0),resol
		addq.l	#2,a0

		move.w	72(sp),d0		; compresion ?
		lsl.b	#7,d0
		move.b	d0,(a1)+		
		move.b	resol,(a1)+	

		moveq.l	#7,d1
pal:		move.l	(a0)+,(a1)+
		dbf.w	d1,pal
;.....................................................
		tst.b	d0
		bne.s	pack_degas
;..................................
		move.w	#7999,d1
copy_pic:	move.l	(a0)+,(a1)+
		dbra.w	d1,copy_pic
		bra	end_prg
;.....................................................
pack_degas:	movea.l	a1,a2	
		adda.l	#33966,a2		; =a1+34000
		moveq.l	#0,d1
		move.b	resol,d1
		mulu.w	#12,d1
		lea.l	param(pc),a6
		adda.w	d1,a6	
		movem.w	(a6)+,d2-d6
		

; a0 a4 source
; a2 a3 tampon 160 byte
; d2 d7 nb_plan
; d3 d1 nb word par ligne
; d4 nb byte par ligne
; d5 nb octets entre de word d'un plan d'image
; d6 nb line par image

ConvertLine:	subq.w	#1,d6			; lignes -1
		bmi	end_prg

		cmpi.b	#2,resol		; Haute rsolution ?
		bne.s	not_hight		; non
		movea.l	a0,a2
		bra.s	not_tri		
	
not_hight	movea.l	a0,a4
		movea.l	a2,a3			; adr tampon 160 octet
		move.w	d2,d7			;  3  1    plans 
tri_plane:	move.w	d3,d1			; 19 39  
tri_byte:	move.w	(a4),(a3)+
		adda.l	d5,a4			;  8  4
		dbra.w	d1,tri_byte
		lea.l	-158(a4),a4 		; plan suivant
		dbra.w	d7,tri_plane

not_tri:	movea.l	a2,a3		 	; dpart premier plan  
		lea.l	0(a2,d4.w),a4		; fin premier plan
		adda.w	(a6),a0			; ligne suivante
		move.w	d2,d7
		bra.s	NewCode
;...............................................
; A1 		but
; A3 		dpart plan dans tampon a2
; A4 		fin    plan dans tampon a2
; A5 		copy a3 pour calcul nb cmd
;
; d0 B		nb octet par plan de ligne
; d1 L/B	some de cmt / octet lu
; d4 		nb byte par ligne
; d7 		nb plan par ligne 
;................................................

NextLine:	subq.b	#1,d7		; plan ligne -1
		bmi.s	ConvertLine	; go to next line
		adda.w	d4,a4		; fin d'un plan de ligne

NewCode:	move.l	a3,a5		; Start adr
		move.b	(a3)+,d0
		cmp.l	a3,a4
		beq.s	CodeCOPY

Same_code:	cmp.b	(a3)+,d0
		bne.s	not_same
		cmp.l	a3,a4
		bne.s	Same_code
		bra.s	save_repeat
	
not_same:	move.l	a3,d1
		sub.l	a5,d1
		cmpi.w	#2,d1		; comparaison sur 3 bytes
		bne.s	CodeREPEAT1

		cmp.l	a3,a4
		beq.s	CodeCOPY

		move.b	-1(a3),d0
NotSameLoop:	move.b	(a3)+,d1
		cmp.b	d0,d1
		beq.s	Same2
		move.b	d1,d0
		cmp.l	a3,a4
		bne.s	NotSameLoop
CodeCOPY_1:	bra.s	CodeCOPY

Same2:		cmp.l	a3,a4
		beq.s	CodeCOPY
		cmp.b	(a3),d0
		bne.s	NotSameLoop
		subq.l	#2,a3

CodeCOPY:	move.l	a3,d1
		sub.l	a5,d1
		subq.w	#1,d1
		move.b	d1,(a1)+
copy:		move.b	(a5)+,(a1)+
		dbf.w	d1,copy

		cmp.l	a3,a4
		bne.s	NewCode
		bra.s	NextLine

CodeREPEAT1:	subq.l	#1,a3
save_repeat:	move.l	a3,d1
		sub.l	a5,d1
		subq.w	#1,d1			; Nb pattern-1
		neg.b	d1
		move.b	d1,(a1)+		; nb repeat
		move.b	d0,(a1)+		; pattern
		cmp.l	a3,a4
		bne.s	NewCode
		bra.s	NextLine
;-----------------------------------------------
end_prg:	move.w	74(sp),d0		; save cycle ?
		beq.s	not_cycle
		move.l	68(sp),a2
		moveq.l	#31,d0
copy_cycle:	move.b	(a2)+,(a1)+		; A1 adresse pair ou impair
		dbf.w	d0,copy_cycle		

not_cycle:	move.l	a1,d0
		move.l	64(sp),d1
		sub.l	d1,d0
		movem.l	(sp)+,d1-d7/a0-a6
		rts	
;.......................................................................
* d2	  3   1  0     plan
* d3	 19  39  0     word par plan
* d4	 40  80  80    octet par plan
* d5	  8   4   2   
* d6	200 200 400    ligne
	even
param:		dc.w	3,19,40,8,200,160	
		dc.w	1,39,80,4,200,160	
		dc.w	0,0,80,2,400,80
	even
resol:		dc.b	0

		end
;************************************************************************