* rockyone			pour MI-9			26/12/2015
* Modifi							04/12/2016
* Ajout test clavier et souris					15/03/2015
;	
*				SCROL_PLAN
*
*			   a0		d1     d2 
*	call scrol_plan(source_image,masque%,sens%,limit%,mous%,mousebut)
*	
*	sens%		75 fleche gauche	
*	     		77 fleche droite
*	     		72 fleche haute
*            		80 fleche bas
*	masque%		%1111 un bit par plan a dplacer
*	plan 	         4321 
*	Limit%		Nombre de word a recopi sur l'cran
*	mous%		bt mouse avant appel
*	mousebut 	= Varpt(mousebut)+6
*
*** rectifier 31840 celon la resolution 
*-------------------------------------------------------------------------
*
*	A0	source et destination
*	A1	buffer temporaire
*	A3      destination
*	D0	resolution
*	D1	masque de plan  %0  %1111 un bit par plan
*	D2	sens
*	D3	nombre de ligne par plan celon rsolution
*	D4	nombre de word par plan sur une ligne celon resololution
*	D5	nombre de byte entre word d'un meme plan celon resolution
*	D6	copie de d3
*	D7      copie de D4
*-------------------------------------------------------------------------
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	64(a7),a0
	movem.w	68(a7),d1-d2	; masque de plan et sens

	movea.l	a0,a6

	move.w	#199,d3		; 200 ligne
	move.b	($44c),d0	; rsolution

	moveq.l	#20,d4		
	lsl.b	d0,d4		; 20 40 80 word par ligne de plan 

	moveq.l	#8,d5		
	lsr.b	d0,d5		; 8 4 2 byte avant prochain word

	btst.b	#0,d2
	beq.s	vertical
;- - - - - - - - - - - - - - - - - - - horizontale - - - - - - - - - - - -
; dplacement par ligne

	cmpi.b	#2,d0		; haute rsolution ?
	bne.s	not_heigh			
	move.w	#399,d3
	move.w	#40,d4

not_heigh
	subq.b	#2,d4		; -1 pour dbra -1 pour le premier word

	cmpi.w	#75,d2
	beq.s	sens_gauche

	lea.l	32000(a0),a0

	suba.w	d5,a0		; destination : dbut plan celon resol
	movea.l	a0,a6
	bra.s	sens_droit

;- - - - - - - - - - - - - - - - - - - verticale - - - - - - - - - - - - -
; dplacement par colonne

vertical:	subq.b	#1,d3
		subq.b	#1,d4

		cmpi.w	#72,d2
		beq	sens_haut
		bra	sens_bas	
	
;-------------------------------------------------------------------------
;......................................	Dcalage vers la gauche		

sens_gauche:	btst.b	#0,d1		; dcaler ce plan ?	
		beq.s	next_p_gauche	; non

		movea.l	a0,a2		; destination
		movea.l	a0,a3		; source
		adda.w	d5,a3		; + 8 4 2 celons resolution

		move.w	d3,d6		; compteur ligne

ligne_gauche:	move.w	(a2),d2		; save premier word du plan
		move.w	d4,d7		; compteur word

word_gauche:	move.w	(a3),(a2)
		adda.w	d5,a2
		adda.w	d5,a3
		dbra.w	d7,word_gauche		; mot suivant

		move.w	d2,(a2)			;copy premier W fin de ligne 
		adda.w	d5,a2
		adda.w	d5,a3
		dbra.w	d6,ligne_gauche		; ligne suivante	

next_p_gauche:	addq.l	#2,a0
		lsr.w	#1,d1
		bne.s	sens_gauche		; plan suivant

		bsr.s	on_screen		; copy sur cran
		tst.w	d0
		bne	end_prg
		bsr.s	vsync	
		bra.s	sens_gauche		

;.....................................	Dcalage vers la droite ..........

sens_droit:	btst.b	#0,d1			; dcaler ce plan ?
		beq.s	next_p_droit		; non 

		movea.l	a0,a2			; destination
		movea.l	a2,a3			; source
		suba.w	d5,a3			; -  8 4 2

		move.w	d3,d6			; compteur ligne

ligne_droit:	move.w	(a2),d2			; save dernier word du plan
		move.w	d4,d7			; compteur word

word_droit:	move.w	(a3),(a2)
		suba.w	d5,a2
		suba.w	d5,a3
		dbra.w	d7,word_droit		; mot suivant
	
		move.w	d2,(a2)			; copy dernier W debut ligne
		suba.w	d5,a2
		suba.w	d5,a3
		dbra.w	d6,ligne_droit		; ligne suivante	
	
next_p_droit:	addq.l	#2,a0			; a0 sur plan prcedant
		lsr.w	#1,d1			; encore un plan a dcaler ?
		bne.s	sens_droit

		bsr.s	on_screen		; copy sur cran
		tst.w	d0
		bne	end_prg
		bsr.s	vsync
		bra.s	sens_droit		
;-------------------------------------------------------------------------

vsync:		movem.l	d0-d2/a0-a2,-(sp)
		move.w	#37,-(sp)		; vsync
		trap	#14
		addq.l	#2,sp
		movem.l	(sp)+,d0-d2/a0-a2	
		rts
;.......................................recopy on screen................
; ajoutez 4 a SP a cause de BSR

on_screen:	move.l	68(sp),a0		; buffer image   64+4(sp)
		move.l	$44e,a1			; screen
		move.w	76(sp),d1		; taille de l'cran visible					

		bsr.s	vsync

recopy:		move.l	(a0)+,(a1)+
		dbra.w	d1,recopy

;............................................... end si D0 <> 0........

*		movem.l	d1-d2/a0-a2,-(sp)
		move.w	#2,-(sp)		; Com
		move.w	#1,-(sp)		; Bconstat
		trap	#13			; Bios
		addq.l	#4,sp
*		movem.l	(sp)+,d1-d2/a0-a2	

		movem.w	78(sp),d6-d7/a0		; Touche "*" 
		tst.b	d6			; Touche repeat active ?
		bne.s	repeat_on
		moveq.l	#1,d0			; stop repeat

repeat_on:	
*		move.w	82(sp),a0		; bt mouse actuel
		cmp.b	1(a0),d7
		beq.s	ok_repeat		; gal   0 or 2
		moveq.l	#1,d0			; stop repeat
			
ok_repeat:	moveq.l	#0,d1
		move.w	72(sp),d1		; restaure masque_plan%
		movea.l	a6,a0			; restaure a0 celons sens%
		bsr.s	vsync
		rts
;-------------------------------------------------------------------------

;.....................................	Dcalage vers le haut ............

sens_haut:	btst.b	#0,d1			; dcaler ce plan ?
		beq.s	next_p_haut		; non

		movea.l	a0,a1
		move.w	d4,d7			; compteur word

word_haut:	movea.l	a1,a2
		lea.l	160(a1),a3

		move.w	(a2),d2			; save word premiere ligne
		move.w	d3,d6			; compteur ligne

ligne_haut:	move.w	(a3),(a2)
		lea.l	160(a2),a2
		lea.l	160(a3),a3
		dbra.w	d6,ligne_haut		;ligne suivante	

		move.w	d2,(a2)			;recopie word fin de ligne 
		adda.w	d5,a1			;saut  8 4 2
		dbra.w	d7,word_haut		; mot suivant

next_p_haut:	addq.l	#2,a0			; a0 sur plan suivant
		lsr.w	#1,d1			; dcale bit masque de plan
		bne.s	sens_haut		; plan suivant ?

		bsr.s	on_screen		; copy sur cran
		tst.b	d0
		bne.s	end_prg
		bra.s	sens_haut	

;.....................................	Dcalage vers le bas ...........

sens_bas:	btst.b	#0,d1			; dcaler ce plan ?	
		beq.s	next_p_bas		; non

		lea.l	31840(a0),a1		; destination
		move.w	d4,d7			; compteur destination
word_bas:	movea.l	a1,a2
		lea.l	-160(a1),a3

		move.w	(a2),d2			; word derniere ligne ecran
		move.w	d3,d6			; compteur ligne

ligne_bas:	move.w	(a3),(a2)
		lea.l	-160(a2),a2
		lea.l	-160(a3),a3
		dbra.w	d6,ligne_bas		; ligne suivante	

		move.w	d2,(a2)			; recopie dernier word 
		adda.w	d5,a1			; saut  8 4 2
		dbra.w	d7,word_bas		; mot suivant

next_p_bas:	addq.l	#2,a0			; a0 sur plan suivant
		lsr.w	#1,d1			; dcale bit masque de plan 	 
		bne.s	sens_bas		; plan suivant ?

		bsr	on_screen		; copy sur cran
		tst.b	d0
		bne.s	end_prg
		bra.s	sens_bas	
;............................................................

end_prg:	movem.l	(a7)+,d0-d7/a0-a6
		rts

		end
;.........................................................................