;rockyone			pour MI-3			02/03/2017
;
;
;			Affiche Menu
;			------------
;
;		call Art_cycle( L source , W position% ,W on_off%)
;		--------------------------------------------------
;
; d1 =  0 menu bas 
;       1 menu haut
; d2 =  0 menu_off
;    =  1 menu_on
;------------------------------------------------------------------------
		movem.l	d0-d7/a0-a6,-(a7)
		movem.l	64(sp),a3-a4

;a3	buffer menu
;a4	buffer image pour menu_off
;a4=a3	pour menu_on
		
		movea.l	$44e,a5		; cran

		moveq.l	#17,d5
		movem.w	72(sp),d1-d2
		
		tst.b	d2
		beq.s	menu_off

;----------------------------------------MENU ON--------------------------
;a3 a4 source
;a5 a6 cran
;
		moveq.l	#39,d6		; 40 LW par ligne	
		tst.b	d1
		beq.s	on_bas
;.......................................

		lea.l	3040(a3),a3	; 19*160	
		lea.l	160(a5),a5	; fin premire ligne
	
		cmpi.b	#2,$44c		; haute resolution ?
		bne.s	loop_h
			
		lea.l	-80(a3),a3	; premire ligne haute rsol
		lea.l	-80(a5),a5	;    "	    "     "     "
		moveq.l	#19,d6		;    "       "     "     "
	
loop_h:		movea.l	a3,a4		; source
		movea.l	a5,a6		; cran
		bsr.s	vsync		; + move d6,d7

h_ligne:	move.l	-(a4),-(a6)
		dbra.w	d7,h_ligne

		lea.l	160(a5),a5	; cran
		addi.w	#40,d6		; +1 ligne, +2 en haute rsol

		dbra.w	d5,loop_h

		bra.s	end_prg

;--------------------------------------- ON BAS -----------------------

on_bas:		lea.l	32000-160(a5),a5

loop_b:		movea.l	a3,a4		; source	
		movea.l	a5,a6		; cran
		bsr.s	vsync		; + move d6,d7
		
b_ligne:	move.l	(a4)+,(a6)+
		dbra.w	d7,b_ligne
				
		lea.l	-160(a5),a5	; cran
		addi.w	#40,d6		; + 1 ligne	
		dbra.w	d5,loop_b

;-------------------------------------------------------------------------

end_prg: 	movem.l	(a7)+,d0-d7/a0-a6
		rts

;-------------------------------------------------------------------------

vsync:		move.w	d6,d7		; Pour les 4 fonctions
		move.w	#37,-(sp)	; Vsync
		trap	#14		; Xbios
		addq.l	#2,sp
		rts

;---------------------------------------- MENU OFF------------------------
menu_off:	lea.l	3040(a3),a3		; 19*160
		move.w	#679,d6			; 17*40 LW   -1 pour dbra	
		moveq.l	#18,d5	
		tst.b	d1
		bne.s	haut_off

;........................................ OFF BAS ........................

		lea.l	29120(a5),a5		; dbut du menu bas Lg 182
		movea.l	a5,a6
		movea.l	a3,a2
		bsr.s	copy_menu		; a5 to a3
		
		movea.l	a2,a3
		lea.l	29120(a4),a4		; buffer image

off_bas:	moveq.l	#39,d3	
		bsr.s	vsync			; + move d6,d7

bas_pic:	move.l	(a4)+,(a6)+		; restaure une ligne image
		dbra.w	d3,bas_pic

		subq.b	#1,d5
		beq.s	end_prg

		movea.l	a3,a2
		movea.l	a6,a5
move_bas:	move.l	(a2)+,(a5)+	;recopy menu une ligne plus bas
		dbra.w	d7,move_bas	
		subi.w	#40,d6
		
		bra.s	off_bas

;........................................ OFF HAUT ........................

haut_off:	lea.l	160(a5),a5		; cran
		bsr.s	copy_menu		

		lea.l	2880(a4),a4		; 18*160 buffer image
		
		cmpi.b	#2,$44c
		bne.s	off_haut
		moveq.l	#17,d5
		suba.w	#80,a3
		suba.w	#80,a4
		suba.w	#80,a5

off_haut:	moveq.l	#39,d3
		bsr.s	vsync			; + move d6,d7

pic_haut:	move.l	-(a4),-(a5)		; restore une ligne d'image
		dbra.w	d3,pic_haut		; 2 en haute rsol.
	
		subq.b	#1,d5
		beq.s	end_haut		; for high resol

		movea.l	a5,a6
		movea.l	a3,a2
			
move_haut:	move.l	-(a2),-(a6)		; menu un ligne plus haut
		dbra.w	d7,move_haut
		subi.w	#40,d6			; -1 ligne, -2 haute rsol

		bra.s	off_haut

end_haut:	cmpi.b	#2,$44c			; high resol ?
		bne	end_prg

		moveq.l	#19,d7
high_rez:	move.l	-(a4),-(a5)
		dbra.w	d7,high_rez
		bra 	end_prg

;---------------------------------------------- copy_menu --------------
; copy 17 lignes du menu qui est a l'ecran.
; pas bessoin de la premire ligne du menu Haut
;  "	"	"    denire ligne du menu bas

copy_menu	move.l	#679,d3		;17*40  -1 pour dbra	
copy_lw:	move.l	(a5)+,(a3)+
		dbra.w	d3,copy_lw
		rts
;-------------------------------------------------------------------------

		end
;-------------------------------------------------------------------------